<template>
    <div class="sw-gs-video-setup-container" v-if="!hasSavedSettings">
        <div class="sw-gs-video-setup-container-inner" :class="{'is-hidden': !isSetupReady}">
            <div class="sw-gs-video-setup-video-wrapper">
                <div class="sw-gs-video-setup-video-wrapper-inner">
                    <SfLoader class="sw-gs-video-setup-loader" :loading="true"/>
                    <div class="sw-gs-video-setup-video-overlay" :class="{'is-hidden': cameraState}">
                        <div v-if="!videoChatEnabled" class="no-cam-box">
                            <SwGsIconCameraOff class="no-cam-icon color-dark-secondary size-l"/>
                            <p class="no-cam-text">{{ $t('Video is disabled in this appointment') }}</p>
                        </div>
                    </div>
                    <video class="sw-gs-video-setup-video"
                           playsinline
                           autoplay
                           muted
                           ref="videoFrame"
                           :class="{'is-hidden': !cameraState}"></video>
                    <div class="sw-gs-video-setup-video-toggle-layer">
                        <SwButton class="sw-gs-video-client-sound-toggle color-light is-circle"
                                  :title="microphoneState === false ? $t('Unmute') : $t('Mute')"
                                  @click="toggleMicrophone()"
                                  :class="{ 'audio-off': microphoneState === false }">
                            <SwGsIconMicOff v-if="microphoneState === false" class="color-dark-secondary size-sm"/>
                            <SwGsIconMicOn v-else class="color-dark-secondary size-sm"/>
                        </SwButton>

                        <SwButton v-if="videoChatEnabled" class="sw-gs-video-client-video-toggle color-light is-circle"
                                  :title="cameraState === false ? $t('Video on') : $t('Video off')"
                                  @click="toggleCamera()"
                                  :class="{ 'video-off': cameraState === false }">
                            <SwGsIconCameraOff v-if="cameraState === false" class="color-dark-secondary size-sm"/>
                            <SwGsIconCameraOn v-else class="color-dark-secondary size-sm"/>
                        </SwButton>
                    </div>
                </div>
            </div>
            <div class="sw-gs-video-setup-settings">
                <SwGsDeviceSettings/>
            </div>
        </div>
    </div>
</template>

<script>
  import { SfLoader } from "@storefront-ui/vue";
  import { watch, ref } from "@vue/composition-api"
  import SwButton from '@/components/atoms/SwButton.vue';
  import SwGsDeviceSettings from './SwGsDeviceSettings.vue';
  import { useVideoSetup } from '../logic/composables/useVideoSetup';
  import { useState } from '../logic/composables/useState';
  import { useVideoCall } from '../logic/composables/useVideoCall';

  import {
    SwGsIconMicOff,
    SwGsIconMicOn,
    SwGsIconCameraOn,
    SwGsIconCameraOff,
} from './icons';
import { VideoAudioSettingsType } from "../logic/interfaces";

export default {
    name: 'SwGsAttendeeNameForm',
    components: {
        SwGsDeviceSettings,
        SfLoader,
        SwButton,
        SwGsIconMicOff,
        SwGsIconMicOn,
        SwGsIconCameraOn,
        SwGsIconCameraOff,
    },
    setup({}) {
        const isSetVideo = ref();
        const { stateForAll } = useState();
        const { initSetup, isSetupReady, hasSavedSettings } = useVideoSetup();
        const { videoChatEnabled, toggleMicrophone, microphoneState, toggleCamera, cameraState } = useVideoCall();
        toggleMicrophone(false);
        toggleCamera(stateForAll.value?.videoAudioSettings === VideoAudioSettingsType.BOTH);

        watch(() => stateForAll.value?.videoAudioSettings, (val) => {
            if (val !== undefined && !isSetVideo.value) {
                toggleCamera(val === VideoAudioSettingsType.BOTH);
                isSetVideo.value = true;
            }
        });

        return {
            videoChatEnabled,
            initSetup,
            hasSavedSettings,
            isSetupReady,
            toggleMicrophone,
            microphoneState,
            toggleCamera,
            cameraState,
        }
    },

    mounted() {
        this.$nextTick(() => {
            this.initSetup(this.$refs.videoFrame);
        })
    }

}
</script>

<style lang='scss' scoped>
@import '@/assets/scss/variables';

.sw-gs-video-setup-container {
    margin-top: 30px;
    max-width: 600px;

    .sw-gs-video-setup-container-inner {
        @include for-tablet {
            display: flex;
        }
        align-items: center;
        justify-content: center;
        opacity: 1;
        transition: opacity 0.15s ease-in;

        &.is-hidden {
            opacity: 0;
        }
    }
}

.sw-gs-video-setup-video-wrapper {
    @include for-tablet {
      aspect-ratio: 3/2;
      width: 46%;
    }
    display: flex;
    align-items: center;
    justify-content: center;

    &:hover {
        .sf-button {
            opacity: 1;
        }
    }
}

.sw-gs-video-setup-video-wrapper-inner {
    position: relative;
    width: 100%;
    height: 100%;
    border-radius: 10px;
}

.sw-gs-video-setup-video-toggle-layer {
    position: absolute;
    top: 10px;
    left: 10px;

    .sf-button {
        margin-bottom: 8px;
        opacity: 0.25;
        transition: opacity 0.15s ease-in;
    }
}

.sw-gs-video-setup-video {
    border-radius: 10px;
    z-index: var(--helper-lay-over-sibling-z-index);
    width: 100%;
    height: 100%;
    opacity: 1;
    transition: opacity 0.15s ease-in;
    object-fit: cover;

    &.is-hidden {
        opacity: 0;
    }
}

.sw-gs-video-setup-settings {
    border-radius: 10px;
    padding: 15px 30px;
    @include for-tablet {
        margin-left: 40px;
        width: 50%;
    }
    border: 1px solid var(--_c-gray-accent);
}

.sw-gs-video-setup-loader {
    height: 70px !important;
    position: absolute;
    top: 50%;
    margin-top: -35px;
    z-index: var(--helper-lay-behind-sibling-z-index); // loading is always set true, so it is always visible
}

.sw-gs-video-setup-video-overlay {
    position: absolute;
    width: 100%;
    height: 94%;
    background-color: var(--c-gray-variant);
    top: 0;
    border-radius: 10px;
    opacity: 1;
    transition: opacity 0.15s ease-in;
    & .no-cam-box {
        width: 100%;
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        .sw-gs-icon {
            margin: 0 auto;
        }
        .no-cam-text {
            margin: 5px 5px 0 5px;
            font-size: 14px;
        }
    }

    &.is-hidden {
        opacity: 0;
    }
}

</style>
